VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cConnect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Enables connection to RSS source
Private WithEvents xDoc As MSXML.DOMDocument
Attribute xDoc.VB_VarHelpID = -1
Private xElement As MSXML.IXMLDOMElement

Public connectURL As String
Public connectKey As String
Private childNode As MSXML.IXMLDOMNode
Public channel As cChannel
Public lastError As String
Private mconnectXML As Boolean

'Declare the events we're going to raise
Public Event docReady(pChannel As cConnect)
Public Event docNotLoaded(pChannel As cConnect, ByVal s As String)

Private Sub Class_Initialize()
  lastError = "No Error description has been found"
  Set xDoc = Nothing
  Set channel = Nothing
End Sub


'setXMLURL
'
' Validates that the URL is sensible and sets it as connection
' Parameters: xmlURL String (i.e. http://blahdeblah.blah.com/doc.xml.rss)
' Returns: True if successful, False if not - lastError contains reason
'
Public Function setXMLURL(xmlURL As String) As Boolean
  'Validation of xmlURL required here
  connectURL = xmlURL
  setXMLURL = True
End Function
'setConnectKey
'
' Parameters:  String (i.e. Moreover Key)
' Returns: True if successful, False if not - lastError contains reason
'
Public Function setConnectKey(Key As String) As Boolean
  'Validation of xmlURL required here
  connectKey = Key
  setConnectKey = True
End Function
'connectToXML
'
' Connects to the XML Source defined by setXMLURL()
' Parameters: none
' Returns: True if successful, False if not - lastError contains reason
'
Public Function connectToXML(Optional bAsync As Boolean = True) As Boolean
  connectToXML = True
  Set xDoc = New MSXML.DOMDocument
  xDoc.async = bAsync
  If Not xDoc.Load(connectURL) Then connectToXML = False
  If xDoc Is Nothing Then connectToXML = True
End Function

Public Sub endConnect()
  Set xDoc = Nothing
  'connectURL = ""
End Sub

Public Function getDoc() As MSXML.DOMDocument
  Set getDoc = xDoc
End Function

Public Function getXML() As String
  getXML = xDoc.xml
End Function

Public Function getChannel() As cChannel
  Set getChannel = channel
End Function

Public Function getLength() As Integer
  getLength = channel.items.length
End Function

Public Function getItem(n As Integer)
  Set getItem = channel.getItem(n)
End Function

'loadNodes
'
' Chops up the XML stuff into an object model
' Parmaeters: none
' Returns: True if successful, False if not, lastError holds the reason
Public Function loadNodes() As Boolean
  Dim xNode As MSXML.IXMLDOMNode
  Dim xyNode As MSXML.IXMLDOMNode
  Dim testNode As MSXML.IXMLDOMNode
  Dim itemNode As MSXML.IXMLDOMNode
  Dim outerItemKids As MSXML.IXMLDOMNodeList
  Dim channelKids As MSXML.IXMLDOMNodeList
  Dim channelNode As MSXML.IXMLDOMNode
  Dim kids As MSXML.IXMLDOMNodeList
  Dim itemKids As MSXML.IXMLDOMNodeList
  Dim channelFound As Boolean
  Dim itemFound As Boolean
  channelFound = False
  itemFound = False
  
  'Move to RDF/RSS node
  Dim tagList As IXMLDOMNodeList
  Dim iFlag As Boolean
  Dim sVer As String
  iFlag = True
  
  ' Check that the document's main element shows a format we can understand,
  ' and set up XML Node Objects
  Set tagList = xDoc.childNodes
  For Each testNode In tagList
    If testNode.nodeName = "rdf:RDF" Then
      sVer = "RSS1"
      Set xNode = testNode
      iFlag = True
    End If
    If testNode.nodeName = "rss" Then
      sVer = "RSS"
      Set xNode = testNode
      iFlag = True
    End If
    If testNode.nodeName = "scriptingNews" Then
      sVer = "scriptingNews"
      Set xNode = testNode
      iFlag = True
    End If
  Next
  
  If Not iFlag Then
    lastError = "No RSS Format files could be found"
    loadNodes = False
    RaiseEvent docNotLoaded(Me, lastError)
    Exit Function
  End If
  ' Trap the wild surmise that iFlag could be true but xNode is empty
  If xNode Is Nothing Then
    lastError = "xNode has nothing in it!"
    loadNodes = False
    RaiseEvent docNotLoaded(Me, lastError)
    Exit Function
  End If
  
  If Not xNode.hasChildNodes Then
    lastError = "No Children Found in the XML Feed"
    loadNodes = False
    RaiseEvent docNotLoaded(Me, lastError)
    Exit Function
  End If
  
  ' Get a channel to hang the items on
  Set channel = New cChannel
  
  ' Walk the list backwards so that we notify (within a channel) in that order!
  Set kids = xNode.childNodes
  Dim j1 As Long
  For j1 = kids.length To 1 Step -1
      Set xyNode = kids.item(j1 - 1)

      '********** CHANNEL SET UP *****************************
      If xyNode.nodeName = "channel" Or xyNode.nodeName = "header" Then
        'Channel found
        channelFound = True
        channel.setVersion sVer
        If xyNode.hasChildNodes Then
          Set channelKids = xyNode.childNodes
          
          Dim j2 As Long
          For j2 = channelKids.length To 1 Step -1
            Set channelNode = channelKids.item(j2 - 1)

            If channelNode.nodeName = "title" Then
              channel.setTitle channelNode.Text
            End If
            If channelNode.nodeName = "channelTitle" Then
              channel.setTitle channelNode.Text
            End If
            If channelNode.nodeName = "link" Then
              channel.setLink channelNode.Text
            End If
            If channelNode.nodeName = "channelLink" Then
              channel.setLink channelNode.Text
            End If
            If channelNode.nodeName = "description" Then
              channel.setDesc channelNode.Text
            End If
            If channelNode.nodeName = "channelDescription" Then
              channel.setDesc channelNode.Text
            End If
            If channelNode.nodeName = "rss091:description" Then
              channel.setDesc channelNode.Text
            End If
            
            ' scriptingNews channel image
            If channelNode.nodeName = "imageUrl" Then
              channel.setImageURL channelNode.Text
            End If
            If channelNode.nodeName = "imageWidth" Then
              channel.setImageWidth channelNode.Text
            End If
            If channelNode.nodeName = "imageHeight" Then
              channel.setImageHeight channelNode.Text
            End If
            
            ' RSS 0.9x channel image
            If channelNode.nodeName = "image" Then
              If channelNode.hasChildNodes Then
                Set itemKids = channelNode.childNodes
                For Each itemNode In itemKids
                  If itemNode.nodeName = "url" Then
                    channel.setImageURL itemNode.Text
                  End If
                  If itemNode.nodeName = "width" Then
                    channel.setImageWidth itemNode.Text
                  End If
                  If itemNode.nodeName = "height" Then
                    channel.setImageHeight itemNode.Text
                  End If
                Next
              End If
            End If
            ' RSS 1.0 channel image handled later
            
            '********** ITEMS SET UP *******************************
            'Add sItems collection
            If channelNode.nodeName = "item" Then
                 itemFound = True
                 Dim item As cItem
                 Dim s As String
                 s = getAttribute(channelNode, "rdf:about")
                 Set item = New cItem
                 item.setAbout s
                 If channelNode.hasChildNodes Then
                     Set itemKids = channelNode.childNodes
                     
                     Dim j4 As Long
                     For j4 = itemKids.length To 1 Step -1
                         Set itemNode = itemKids.item(j4 - 1)

                         If itemNode.nodeName = "text" Then  ' scriptingNews
                             item.setDesc itemNode.Text
                         End If
                         If itemNode.nodeName = "title" Then
                             item.setTitle itemNode.Text
                         End If
                         If itemNode.nodeName = "link" Then
                             If sVer = "scriptingNews" Then
                                 item.setDesc fixLinks(item.getDesc(), itemNode)
                             Else
                                 item.setLink itemNode.Text
                             End If
                         End If
                         If itemNode.nodeName = "description" Then
                             item.setDesc itemNode.Text
                         End If
                         If itemNode.nodeName = "dc:description" Then
                             item.setDesc itemNode.Text
                         End If
                         If itemNode.nodeName = "rss091:description" Then
                             item.setDesc itemNode.Text
                         End If
                         If itemNode.nodeName = "dc:type" Then
                             item.setType itemNode.Text
                         End If
                         If itemNode.nodeName = "ag:source" Then
                             item.setSource itemNode.Text
                         End If
                         If itemNode.nodeName = "enclosure" Then
                             item.addEnclosure getAttribute(itemNode, "url"), getAttribute(itemNode, "type")
                         End If
                         If itemNode.nodeName = "content:items" Then
                             parseEnclosures item, itemNode
                         End If
                     Next
                 End If
             channel.addItem item
             End If
        
        '********** END ITEMS SET UP *****************************
          Next
        End If
       End If
       '********** END CHANNEL SET UP *****************************
       
       
       '********** ITEMS SET UP *******************************
       'Add sItems collection
       If xyNode.nodeName = "item" Then
            itemFound = True
            Dim outerItem As cItem
            Dim outerS As String
            outerS = getAttribute(xyNode, "rdf:about")
            Set outerItem = New cItem
            outerItem.setAbout outerS
            If xyNode.hasChildNodes Then
                Set outerItemKids = xyNode.childNodes

                Dim j5 As Long
                For j5 = outerItemKids.length To 1 Step -1
                    Set testNode = outerItemKids.item(j5 - 1)

                    If testNode.nodeName = "text" Then  ' scriptingNews
                        outerItem.setDesc testNode.Text
                    End If
                    If testNode.nodeName = "title" Then
                        outerItem.setTitle testNode.Text
                    End If
                    If testNode.nodeName = "link" Then
                        If sVer = "scriptingNews" Then
                            outerItem.setDesc fixLinks(outerItem.getDesc(), testNode)
                        Else
                            outerItem.setLink testNode.Text
                        End If
                    End If
                    If testNode.nodeName = "description" Then
                        outerItem.setDesc testNode.Text
                    End If
                    If testNode.nodeName = "dc:description" Then
                        outerItem.setDesc testNode.Text
                    End If
                    If testNode.nodeName = "rss091:description" Then
                        outerItem.setDesc testNode.Text
                    End If
                    If testNode.nodeName = "dc:type" Then
                        outerItem.setType testNode.Text
                    End If
                    If testNode.nodeName = "ag:source" Then
                        outerItem.setSource testNode.Text
                    End If
                    If testNode.nodeName = "enclosure" Then
                        outerItem.addEnclosure getAttribute(testNode, "url"), getAttribute(testNode, "type")
                    End If
                    If testNode.nodeName = "content:items" Then
                        parseEnclosures outerItem, testNode
                    End If
                Next
            End If
            channel.addItem outerItem
        End If
        
        '********** ITEMS SET UP *****************************
        If Not channelFound Then
            lastError = "No channel tag was found"
        End If
        If Not itemFound Then
            lastError = "No item tag was found"
        End If
  Next

  loadNodes = True
  RaiseEvent docReady(Me)
  
End Function

Private Function fixLinks(sDesc As String, pNode As MSXML.IXMLDOMNode)
    ' Search pNode for <url> and <linetext>
    Dim sURL As String
    Dim sTxt As String
    Dim nIndex As Integer
    sURL = ""
    sTxt = ""
    nIndex = 0
    If pNode.hasChildNodes Then
        Dim pKids As MSXML.IXMLDOMNodeList
        Dim node As MSXML.IXMLDOMNode
        Set pKids = pNode.childNodes
        For Each node In pKids
            If node.nodeName = "url" Then sURL = node.Text
            If node.nodeName = "linetext" Then sTxt = node.Text
        Next node
    End If
    If sTxt <> "" Then
        nIndex = InStr(sDesc, sTxt)
    End If
    If nIndex <= 0 Then
        ' No text for the URL to match with.
        ' Append the URL to the description.
        sDesc = sDesc + "<br><a href=""" + sURL + """>" + sURL + "</a>"
    Else
        ' Replace the substring with a link to the URL
        If nIndex > 0 Then
            sDesc = Left$(sDesc, nIndex - 1) + "<a href=""" + sURL + """>" + sTxt + "</a>" + Mid$(sDesc, nIndex + Len(sTxt))
        Else
            sDesc = "<a href=""" + sURL + """>" + sTxt + "</a>" + Mid$(sDesc, nIndex + Len(sTxt))
        End If
    End If
    fixLinks = sDesc
End Function

Private Sub parseEnclosures(destItem As cItem, pNode As MSXML.IXMLDOMNode)
    ' Parse the RSS 1.0
    ' <content:items>
    '   <rdf:Bag>
    '     <rdf:li>
    '       <content:item rdf:about="contentURI">
    '         <content:format rdf:resource="uri"/>
    '         <content:encoding rdf:resource="stuff"/>
    '         <rdf:value>...value if no rdf:about specified...</rdf:value>
    '       </content:item>
    '     </rdf:li> (...)
    '   </rdf:Bag>
    ' </content:items>
    ' (we won't support inline content values, only URI referenced values)
End Sub

Private Function getAttribute(xNode As MSXML.IXMLDOMNode, sAtt As String) As String
  'Return the about attribute of the passed node
  Dim attList As IXMLDOMNamedNodeMap
  Set attList = xNode.Attributes
  Dim testNode As MSXML.IXMLDOMNode
  Dim returnStr As String
  ' try: returnStr=attList.getNamedItem(sAtt).nodeValue
  For Each testNode In attList
    If testNode.nodeName = sAtt Then
      returnStr = testNode.nodeValue
    End If
  Next testNode
  getAttribute = returnStr
End Function


' OnReadyStateChange() called when the XML document is ready (or not).
'
Private Sub xDoc_onreadystatechange()
    If xDoc.parseError = 0 And xDoc.readyState = 4 Then
      mconnectXML = True
      loadNodes
    Else
      If xDoc.readyState = 4 And xDoc.parseError <> 0 Then
        lastError = "An error has occurred in connecting to the XML source"
        endConnect
        mconnectXML = False
        ' Raising the docnotloadded event
        RaiseEvent docNotLoaded(Me, lastError)
      End If
    End If
End Sub

Public Property Get connectXML() As Variant
    connectXML = mconnectXML
End Property


