VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cNewsClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'cNewsClient
Option Explicit
'News Client Class
'MODIFICATION HISTORY
'
'   tb  2001-05-09  created
'   hp  2001-05-15  added bAsync connection flag, OnError event
'   hp  2001-05-22  remove most of the facade, let caller handle events directly
'

' Private myInstances As New Collection
Private WithEvents instanceConnect As cConnect
Attribute instanceConnect.VB_VarHelpID = -1

'Declare the events we will raise
Public Event RSSSourceReady(pConnect As cConnect, ByVal rSrcHandle As String)
Public Event OnError(pConnect As cConnect, ByVal sSrcHandle As String, ByVal sError As String, ByVal sContext As String)
'


Public Function GetNewRSSSource(uPotentialRSSSource As String, connectKey As String, Optional bAsync As Boolean = True) As cConnect

    ' Check we're not already listening to this feed!
    
    ' Create a new connection to the RSS feed
    Set instanceConnect = New cConnect
    
    If Not (instanceConnect.setConnectKey(connectKey)) Then
      Call rtError(Nothing, connectKey, instanceConnect.lastError, "setting channel key")
      Set GetNewRSSSource = Nothing
      Exit Function
    End If
    'Connect
    If Not (instanceConnect.setXMLURL(uPotentialRSSSource)) Then
      Call rtError(Nothing, connectKey, instanceConnect.lastError, "setting XML URL")
      Set GetNewRSSSource = Nothing
      Exit Function
    End If
    
    If Not instanceConnect.connectToXML(bAsync) Then
      Call rtError(Nothing, connectKey, instanceConnect.lastError, "conecting to XML URL")
      Set GetNewRSSSource = Nothing
      Exit Function
    End If
   
'    myInstances.Add instanceConnect
    Set GetNewRSSSource = instanceConnect
End Function


'rtError
'
'Error handling routine. Need to think about where the message is thrown to
'Parameters: rtErr$ error description, rtActivity$ activity in progress
Private Sub rtError(instanceConnect As cConnect, sSrcHandle As String, sErr As String, sContext As String)
  ' Throw errors further up the chain
  RaiseEvent OnError(instanceConnect, sSrcHandle, sErr, sContext)
End Sub

'Handle the event coming out of cConnect
'Private Sub instanceConnect_docNotLoaded(ByVal s As String)
    'Call rtError(instanceConnect, instanceConnect.connectKey, s, "loading XML document")
'End Sub

'Handle the event coming out of cConnect
'Private Sub instanceConnect_docReady()
  'RaiseEvent RSSSourceReady(instanceConnect, instanceConnect.connectKey)
'End Sub

Public Function SourceConnect(pSource As GrooveTransport.IGrooveHTTPSource, nLinger As Long) As Long
    SourceConnect = pSource.Connect(nLinger)
End Function

Public Sub SourceDisconnect(pSource As GrooveTransport.IGrooveHTTPSource)
    pSource.Disconnect
End Sub

Public Function SourceGet(pSource As GrooveTransport.IGrooveHTTPSource, sURL As String, pHeaderEnum As IGrooveBSTREnum, nPriority As Integer) As IGrooveByteInputStream
    Dim pStream As IGrooveByteInputStream
    Dim pRespHeaders As IGrooveBSTREnum
    Dim nResult As Long
    Set pStream = Nothing
    
    Dim pResult As IGrooveHTTPResult
    Set pResult = pSource.Get(sURL, pHeaderEnum, nPriority)
    Set pStream = pResult.responseBody
    
    ' nResult = pSource.Get(sURL, pHeaderEnum, nPriority, pRespHeaders, pStream)
    
    If pStream Is Nothing Then
    ' MsgBox "No stream"
    Else
    ' MsgBox pStream.GetSize
    End If
    Set SourceGet = pStream
End Function
