VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cNewsGlue"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Data model delegate for the Agora/Cabezal news client tool.
' Used for
'  - one-time initialisation
'  - access by external tools, bots and so on
'
' These main interfaces:
Implements GrooveComponents.IGrooveComponent
Implements GrooveComponents.IGrooveDataComponent

Const PROPERTY_TOOL As String = "_Tool"
Const PROPERTY_TELESPACE As String = "_Telespace"
Const COMMON_PROPERTY_NAME = "Name"
Const COMMON_PROPERTY_BINDABLE_URL = "_BindableURL"
Const COMMON_PROPERTY_CANONICAL_URL = "_CanonicalURL"

Dim m_pIPropertyList As GrooveComponents.IGroovePropertyList


Private Sub IGrooveComponent_BeginComponentConnections()
    ' do nothing
End Sub

Private Sub IGrooveComponent_ConnectToComponent(ByVal i_pIComponent As GrooveComponents.IGrooveComponent, ByVal i_ConnectionID As Long)
    ' nothing: we're not connecting to other components yet
End Sub

Private Sub IGrooveComponent_PreUnconnectFromComponents()
    ' nothing
End Sub

Private Sub IGrooveComponent_UnconnectFromComponents()
    ' nothing
End Sub

Private Sub IGrooveComponent_EndComponentConnections()
    ' nothing (yet)
End Sub

Private Property Get IGrooveComponent_BindableURL() As String
    IGrooveComponent_BindableURL = m_pIPropertyList.OpenPropertyAsString(COMMON_PROPERTY_BINDABLE_URL)
End Property

Private Property Get IGrooveComponent_CanonicalURL() As String
    IGrooveComponent_CanonicalURL = m_pIPropertyList.OpenPropertyAsString(COMMON_PROPERTY_CANONICAL_URL)
End Property

Private Function IGrooveComponent_OpenName() As String
    IGrooveComponent_OpenName = m_pIPropertyList.OpenPropertyAsString(COMMON_PROPERTY_NAME)
End Function

Private Sub IGrooveComponent_Initialize(ByVal i_pIPropertyList As GrooveComponents.IGroovePropertyList)
    'Save reference to property list
    'MsgBox "init"
    Set m_pIPropertyList = i_pIPropertyList
End Sub

Private Sub IGrooveComponent_Terminate()
    ' nothing to do
End Sub

Private Sub IGrooveDataComponent_OneTimeInitialize(ByVal i_pInitializationPropertyList As GrooveComponents.IGroovePropertyList)
    '
    ' Initialisation when a bootstrap propertylist is passed us from a telespace-template .GRV file.
    ' If so, we just write it as a property on the tool, which will pick it up when loaded.
    '
'    MsgBox "bootstrap"
    
    ' Make sure we have a propertylist
    If m_pIPropertyList Is Nothing Then
'        MsgBox "Error: no propertylist!"
        Exit Sub
    End If
    
    ' Create a new propertylist to store the bootstrap properties
    Dim pTelespace As IGrooveTelespace
    Dim pPrefProv As IGroovePreferencesProvider
    Dim pPrefs As GrooveComponents.IGroovePropertyList
    Dim sToolURL As String
    Dim sPropName As String
    
    Set pTelespace = m_pIPropertyList.OpenProperty(PROPERTY_TELESPACE)
'    MsgBox pTelespace.OpenCanonicalURL
    Set pPrefProv = pTelespace.PreferencesProvider
'    MsgBox "got prefprov"
    Set pPrefs = pPrefProv.PropertyList
'    MsgBox "got prefs"
    Dim pTool As IGrooveTool
    Set pTool = m_pIPropertyList.OpenProperty(PROPERTY_TOOL)
'    MsgBox "got tool"
    sToolURL = pTool.CanonicalURL
'    MsgBox sToolURL
    sPropName = sToolURL + "_BootstrapProperties"
    
    ' Copy all the bootstrap properties into our new propertylist
    Dim pBootstrap As IGrooveElement
    If i_pInitializationPropertyList.PropertyExists("Bootstrap") Then
        Set pBootstrap = i_pInitializationPropertyList.OpenPropertyAsElement("Bootstrap")
        pPrefs.SetPropertyAsElement sPropName, pBootstrap.OpenContentElement(0)
    End If
    
End Sub
